<?php
  header('Content-type: application/json; charset=utf-8');
  // header('Cache-Control: max-age=30');
  // header('Location: http://'.$_SERVER['SERVER_NAME'].'/camas' );
  //require('sqlsrv.php');
// SECCION DE DEFINICION DE FUNCIONES
// INTERCONSULA
function Intercons($CC, $CI, $conn){
  $interconsultas="";
  $qInt = "SELECT CASE M.MECODE
  WHEN 21 THEN 'ANEST' WHEN 22 THEN 'ANEST' WHEN 387 THEN 'MI' WHEN 137 THEN 'CX'
  WHEN 138 THEN 'MX' WHEN 143 THEN 'CX-P' WHEN 190 THEN 'UCI' WHEN 410 THEN 'NF'
  WHEN 440 THEN 'NCX' WHEN 441 THEN 'NEURO' WHEN 450 THEN 'NUT' WHEN 550 THEN 'PED'
  WHEN 730 THEN 'TR' WHEN 750 THEN 'URO' WHEN 782 THEN 'INF' WHEN 783 THEN 'CH'
  WHEN 784 THEN 'MCX' WHEN 514 THEN 'ORT' WHEN 382 THEN 'MG'WHEN 430 THEN 'NEUMO'
  WHEN 392 THEN 'MI'
  ELSE 'N/C'
  END [MENOME],
  COUNT(M.MENOME) CANT FROM INTERCN I
  INNER JOIN MAEESP M ON M.MECODE = I.MECodE WHERE I.HISCKEY='$CC'
  AND I.IntCtvIn='$CI' AND I.IntEst IN('O') AND M.ESPEST='S' AND M.ESPINDINT='S' AND M.MECodE NOT IN('42','52','391','360','601','602','999')
  GROUP BY M.MENOME, M.MECodE";
  $dInt = sqlsrv_query($conn, $qInt);
  while ($f = sqlsrv_fetch_array($dInt, SQLSRV_FETCH_ASSOC)) {
    $int = $f['MENOME'];
    $interconsultas .= $int." ";
  }
  sqlsrv_free_stmt($dInt);
  return $interconsultas;
}

function TipoSalida($Ced, $CoI, $conn) {
  $qTipoSalida = "SELECT RTRIM(IngMotSal) FROM INGRESOS WHERE MPCEDU='$Ced' AND IngCsc='$CoI' ";
  $tipoSalida = sqlsrv_query($conn, $qTipoSalida);
  $salida = (sqlsrv_fetch($tipoSalida)) ? sqlsrv_get_field($tipoSalida, 0) : "";
  sqlsrv_free_stmt($tipoSalida);
  return $salida;
}

// RIESGOS
function folio_riesgos($Ced, $conn){
  $qRiesgo = "SELECT MAX(RESFOLPAC) Folio FROM RESENCU WHERE EMPCOD='1' AND MCDPTO='001' AND ENCCOD='FTBPTE' AND RESDOCPAC='".$Ced."' ";
  $dRiesgos = sqlsrv_query($conn, $qRiesgo);
  if (sqlsrv_fetch($dRiesgos)) {
    $folio = sqlsrv_get_field($dRiesgos, 0);
  }
  $detalle = ($folio!=null) ? detalleR($Ced, $folio, $conn): "";
  sqlsrv_free_stmt($dRiesgos);
  return $detalle;
}

function detalleR($Ced, $folio, $conn){
  $qDetRiesgo = "SELECT ResEncCtv, ResObser, ResSele FROM RESENCU1 WHERE EMPCOD='1' AND MCDPTO='001' AND EncCod='FTBPTE' AND RESDOCPAC='".$Ced."' AND ResFolPac='".$folio."'";
  $riesgosDet = sqlsrv_query($conn, $qDetRiesgo);
  $ESP = "";
  $espTra = "";
  $caida = "";
  $alPsq = "";
  $ulcPre = "";
  while($f = sqlsrv_fetch_array($riesgosDet, SQLSRV_FETCH_ASSOC)){
    $i = $f['ResEncCtv'];
    $sele = $f['ResSele'];
    if ($i<21) {
      $ESP .= abrEsp($i, $sele);
    }else{
      switch($i){
        case 21: $espTra = $f['ResObser']; break;
        case 23: $caida = $f['ResSele']; break;
        case 24: $alPsq = $f['ResSele']; break;
        case 25: $ulcPre = $f['ResSele']; break;
      }
    }
  }
    $risks = array('esp' => $ESP." ",'espTra' => strtoupper($espTra." "),
    'caida' => $caida, 'alPsq' => $alPsq, 'ulcPre' => $ulcPre );
    sqlsrv_free_stmt($riesgosDet);
    return json_encode($risks);
  }

function abrEsp($i, $s){
  $e = "";
  switch ($i) {
   case 2: $e .= ($s==1) ? "ANE " : ""; break;
   case 3: $e .= ($s==1) ? "CX " : ""; break;
   case 4: $e .= ($s==1) ? "MX " : ""; break;
   case 5: $e .= ($s==1) ? "CX_PED " : ""; break;
   case 6: $e .= ($s==1) ? "CX_P ": ""; break;
   case 8: $e .= ($s==1) ? "GO " : ""; break;
   case 9: $e .= ($s==1) ? "INFECTO ": ""; break;
   case 10: $e .= ($s==1) ? "MI " : ""; break;
   case 11: $e .= ($s==1) ? "MICROCX " : ""; break;
   case 12: $e .= ($s==1) ? "NCX " : ""; break;
   case 13: $e .= ($s==1) ? "NUT " : ""; break;
   case 15: $e .= ($s==1) ? "ORT " : ""; break;
   case 16: $e .= ($s==1) ? "OTORRINO " : ""; break;
   case 17: $e .= ($s==1) ? "PED " : ""; break;
   case 18: $e .= ($s==1) ? "TR " : ""; break;
   case 19: $e .= ($s==1) ? "TOX " : ""; break;
   case 20: $e .= ($s==1) ? "URO" : ""; break;
   }
   return $e;
}

// RESERVA CAMAS
function CamaReservada($Cama, $conn){
  $qreservada = "SELECT MPNCREEST RES FROM MAEPABRES WHERE MPNUMC='$Cama' AND MPNCREEST='A'";
  $reservada = sqlsrv_query($conn, $qreservada);
  $reser = (sqlsrv_fetch($reservada)) ? sqlsrv_get_field($reservada, 0) : 0;
  return ($reser==="A") ? 10 : 0;
}
// AISLAMIENTO
function folio_aisla($Ced, $conn){
  $qAIS = " SELECT MAX(RESFOLPAC) Folio FROM RESENCU WHERE RESDOCPAC='".$Ced."' AND ENCCOD='FTBPTE' ";
  $rAIS = sqlsrv_query($conn, $qAIS);
  sqlsrv_fetch($rAIS);
  $Folio = sqlsrv_get_field($rAIS,0);
  sqlsrv_free_stmt($rAIS);
  if ($Folio!==null && $Folio!=="") {
    return detalleAisla($Ced, $Folio, $conn);
  }
  return 0;
}

function detalleAisla($Ced, $Folio, $conn){
  $qDetAis = " SELECT ResSele FROM RESENCU1 WHERE RESDOCPAC='".$Ced."' AND ENCCOD='FTBPTE' AND RESFOLPAC='".$Folio."' AND ResEncCtv ='27' ";
  $d = sqlsrv_query($conn, $qDetAis);
  $resencctv = (sqlsrv_fetch($d)) ? sqlsrv_get_field($d, 0) : 0;
  sqlsrv_free_stmt($d);
  return $resencctv;
}

// HORA APERTURA ULTIMO FOLIO MEDICO
function HoraFolioMedico($ced, $coI, $conn)
{
  $qHF = "SELECT TOP(1) RTRIM( CONVERT(VARCHAR, HISCFCON, 120)) FROM HCCOM1
          WHERE HISCKEY='$ced' AND HCtvIn1= '$coI' AND HCEsp NOT IN ('42', '391')
          ORDER BY HISCSEC DESC";
  $h = sqlsrv_query($conn, $qHF);
  if (sqlsrv_fetch($h)) {
    $horaFolio = sqlsrv_get_field($h, 0);
  }else {
    $horaFolio = "";
  }
  sqlsrv_free_stmt($h);
  return $horaFolio;
}

// ESQUELETO
  if ( isset($_GET['codPabellon']) ) {
    require('sqlsrv.php');
    set_time_limit(0);
    $conn = sqlsrv_connect($serverName, $connectionInfo);
    if ($conn === false) {
      die( print_r( sqlsrv_errors(), true));
    }
    $cp = filter_input(INPUT_GET, 'codPabellon', FILTER_SANITIZE_NUMBER_INT);
    $query = " SELECT M1.MPNUMC CAMA, M1.MPUced, M1.MPUDoc, M1.MPCtvIn, ME.MENOMB EPS,
     ( CASE(IngFecEgr) WHEN '1753-01-01 00:00:00.000' then 0 ELSE 1 END) ALTA, M1.MPDisp EST, M11.HisCamHor HORA,
     DATEDIFF(DAY, IngFecAdm, GETDATE()) DIAS,
     (CASE WHEN DATEPART(MONTH, C.MPFchN) = DATEPART(MONTH, GETDATE()) AND DATEPART(DAY, C.MPFchN) = DATEPART(DAY, GETDATE()) THEN 1 ELSE 0 END) FECHAN
     FROM MAEPAB1 M1
     LEFT JOIN CAPBAS C ON M1.MPUDoc = C.MPTDoc AND M1.MPUced = C.MPCedu
     LEFT JOIN INGRESOS I ON M1.MPUCED = I.MPCEDU AND I.IngCsc = M1.MPCtvIn AND M1.MPUDoc = I.MPTDOC
     LEFT JOIN MAEEMP ME ON ME.MENNIT = I.IngNit
     LEFT JOIN MAEPAB11 M11 ON M1.MPNumC = M11.MPNumC AND M1.MPCodP = M11.MPCodP AND M1.MPDisp='9'
     AND M11.HisCamCtv=CONVERT(INT,M1.MpUltCtvo) AND M11.HisCamEdo='D'
     WHERE M1.MPCodP = '".$cp."' AND M1.MPActCam='N' ORDER BY CAMA ";
    $camas = sqlsrv_query($conn, $query);
    if ($camas) {
      while ($datos = sqlsrv_fetch_array($camas, SQLSRV_FETCH_ASSOC)) {
        $tienePqx = 0;
        $espTratante = "";
        $riesgoCaida = "";
        $riesgoAl_Psi = "";
        $riesgoUlxPre = "";
        $pteAislado = false;
        $c['CAMA'] = $datos['CAMA'];
        $c['EPS'] = $datos['EPS'];
        $c['PROCQX'] = "";
        $c['INTER'] = "";
        $c['ALTA'] = intval($datos['ALTA']);
        $c['EST'] = intval($datos['EST']);
        $c['HORA'] = $datos['HORA'];
        $c['DIAS'] = $datos['DIAS'];
        $c['HFM'] = "";
        $c['FECHAN'] = $datos['FECHAN'];
        // DECLARACION DE VARIABLES QUE OBTIENEN LA CEDULA Y CONSECUTIVO DE INGRESO DEL PACIENTE
        $cedula = trim($datos['MPUced']);
        $ingreso = trim($datos['MPCtvIn']);
        $tipodoc = trim($datos['MPUDoc']);

        if ( strlen($cedula) > 4) {
          // VERIFICACION DE INTERCONSULTAS PENDIENTES PARA LOS PACIENTES
          $c['INTER'] = Intercons($cedula, $ingreso, $conn);
          // VERIFICACION DE TIPO DE SALIDA (SALUD EN CASA O REMISION)
          $salida = TipoSalida($cedula, $ingreso, $conn);

          $rem = ($salida === "R") ? : "";
          $scasa = ($salida === "SD") ? : "";
          // VERIFICACION DE RIESGOS
          $dRiesgos = folio_riesgos($cedula, $conn);
          if($dRiesgos !== null && $dRiesgos !== "" ){
            $dRiesgos = json_decode($dRiesgos);
            $espTratante .=  $dRiesgos -> {'espTra'} . $dRiesgos -> {'esp'} ;
            $riesgoCaida = $dRiesgos -> {'caida'};
            $riesgoAl_Psi = $dRiesgos -> {'alPsq'};
            $riesgoUlxPre = $dRiesgos -> {'ulcPre'};
          }
          // FUNCION PARA VERIFICAR SI EL PACIENTE ESTA AISLADO
          $pteAislado = folio_aisla($cedula, $conn);
          // VERIFICA SI LA CAMA ESTA RESERVADA
          // if ($c['EST'] === 0) {
          //   $c['EST'] = CamaReservada($c['CAMA']);
          // }
          // VERIFICA SI TIENE LABORATORIOS, RX PENDIENTES, PROC NO QX, PROC QX
          $query2 = "SELECT DISTINCT(HCPrcTpoP) FROM HCCOM51 WHERE HISCKEY='$cedula' AND HISTipDoc='$tipodoc' ".
          " AND HCtvIn51='".$datos['MPCtvIn']."' AND HCPrcEst IN('O', 'E') AND HCPrcCod NOT IN('999001') AND HCFcHrOrd >= (getDate()-2) ";
            $proced1 = sqlsrv_query($conn, $query2);
            while ($lb = sqlsrv_fetch_array($proced1, SQLSRV_FETCH_ASSOC)) {
              switch ($lb['HCPrcTpoP']) {
                case '5': $tienePqx+=1; break;
              }
            }
            // COMPRUEBA LOS RESULTADOS OBTENIDOS PARA ESTABLECER LOS VALORES QUE SE VAN A ENVIAR A LA TABLA
            if ( $tienePqx>0 ) { $c['PROCQX'] = 'SI'; }else{ $c['PROCQX'] = 'NO'; }
            // CONSULTA HORA FOLIO MEDICO
            $c['HFM'] = HoraFolioMedico($cedula, $ingreso, $conn);
        }else{
          $c['DIAS'] = 0;
          $c['PROCQX'] = 'NO';
          $c['INTER'] = "";
          // VERIFICA SI LA CAMA ESTA RESERVADA
          if ($c['EST'] === 0) {
            $c['EST'] = CamaReservada($c['CAMA'], $conn);
          }
          $rem = "";
          $scasa = "";
          $pteAislado = false;
          $c['HFM'] = "";
        }

        // CREAR EL ARRAY CON LA ESTRUCTURA JSON PARA SER ENVIADA AL ARCHIVO JAVASCRIPT
        $ca[] = array(
          "cama" => $c['CAMA'],"dias" => $c['DIAS'],"esp" => $espTratante,
          "eps" => $c['EPS'],"procqx" => $c['PROCQX'],"inter" => $c['INTER'],
          "rem" => $rem,"scasa" => $scasa,"alta" => $c['ALTA'],"est" => $c['EST'],
          "riesgoCaida" => $riesgoCaida,"riesgoAl_Psi" => $riesgoAl_Psi,
          "riesgoUlxPre" => $riesgoUlxPre,"aislado" => $pteAislado,"hora" => $c['HORA'], "hfm" => $c['HFM'], "fechaN"=>$c['FECHAN']);
      }
      $ca = json_encode($ca);
      if (isset($proced1)) {
        sqlsrv_free_stmt($proced1);
      }
      sqlsrv_free_stmt($camas);   
      sqlsrv_close($conn);
      echo $ca;
    }
  }
?>
